package cn.com.qmth.examcloud.core.basic.service;

import cn.com.qmth.examcloud.commons.base.exception.StatusException;
import cn.com.qmth.examcloud.commons.web.security.bean.User;
import cn.com.qmth.examcloud.core.basic.service.bean.LoginInfo;

/**
 * 鉴权
 *
 * @author WANGWEI
 * @date 2018年5月25日
 * @Copyright (c) 2018-? http://qmth.com.cn All Rights Reserved.
 */
public interface AuthService {

	/**
	 * 登录
	 *
	 * @author WANGWEI
	 * @param loginInfo
	 * @return
	 */
	User login(LoginInfo loginInfo);

	/**
	 * 登出
	 *
	 * @author WANGWEI
	 * @param user
	 */
	void logout(User user);

	/**
	 * 获取登录用户
	 *
	 * @author WANGWEI
	 * @param key
	 * @param token
	 * @return
	 */
	User getLoginUser(String key, String token);

	/**
	 * 第三方登陆名接入
	 *
	 * @author WANGWEI
	 * @param orgId
	 * @param loginName
	 * @param appId
	 * @param timestamp
	 * @param token
	 * @return
	 * @throws StatusException
	 */
	User thirdPartyAccess(long orgId, String loginName, String appId, String timestamp,
			String token) throws StatusException;

}
