package cn.com.qmth.examcloud.core.basic.service.impl;

import java.util.List;
import java.util.Set;

import javax.transaction.Transactional;

import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.google.common.collect.Lists;
import com.google.common.collect.Sets;

import cn.com.qmth.examcloud.core.basic.dao.OrgRepo;
import cn.com.qmth.examcloud.core.basic.dao.PrivilegeGroupRepo;
import cn.com.qmth.examcloud.core.basic.dao.PrivilegeRepo;
import cn.com.qmth.examcloud.core.basic.dao.RolePrivilegeRelationRepo;
import cn.com.qmth.examcloud.core.basic.dao.entity.PrivilegeEntity;
import cn.com.qmth.examcloud.core.basic.dao.entity.RolePrivilegeRelationEntity;
import cn.com.qmth.examcloud.core.basic.service.RolePrivilegeService;

/**
 * 类注释
 *
 * @author WANGWEI
 * @date 2018年6月14日
 * @Copyright (c) 2018-? http://qmth.com.cn All Rights Reserved.
 */
@Service
@Transactional
public class RolePrivilegeServiceImpl implements RolePrivilegeService {

	@Autowired
	PrivilegeRepo privilegeRepo;

	@Autowired
	OrgRepo orgRepo;

	@Autowired
	RolePrivilegeRelationRepo rolePrivilegeRelationRepo;

	@Autowired
	PrivilegeGroupRepo privilegeGroupRepo;

	@Autowired
	RolePrivilegeService rolePrivilegeService;

	@Override
	public void updateRolePrivilegeRelations(Long rootOrgId, Long roleId, Long privilegeGroupId,
			Set<Long> privilegeIdSet) {

		List<PrivilegeEntity> privilegeList = privilegeRepo
				.findAllByGroupIdOrderByWeightDesc(privilegeGroupId);

		for (PrivilegeEntity cur : privilegeList) {
			rolePrivilegeRelationRepo.deleteByRoleIdAndRootOrgIdAndPrivilegeId(roleId, rootOrgId,
					cur.getId());
		}

		if (CollectionUtils.isEmpty(privilegeIdSet)) {
			return;
		}

		Set<String> temp = Sets.newHashSet();

		List<RolePrivilegeRelationEntity> list = Lists.newArrayList();
		for (Long cur : privilegeIdSet) {
			if (0 > cur) {
				continue;
			}

			if (temp.contains(String.valueOf(cur))) {
				continue;
			}
			temp.add(String.valueOf(cur));
			RolePrivilegeRelationEntity bean = new RolePrivilegeRelationEntity();
			bean.setRoleId(roleId);
			bean.setRootOrgId(rootOrgId);
			bean.setPrivilegeId(cur);

			list.add(bean);
		}

		rolePrivilegeRelationRepo.save(list);
	}

}
